C                             ************************************
C                             ***  BIT MANIPULATION FUNCTINS   ***
C                             ************************************
C
C                             THE BIT MANIPULATION FUNCTIONS IBSET
C                             AND BTEST GIVEN BELOW ARE HIGHLY
C                             PORTABLE BUT VERY INEFFICIENT.  IF
C                             EQUIVALENT INTRINSIC FUNCTIONS ARE
C                             AVAILABLE, IBSET AND BTEST SHOULD BE
C                             MODIFIED TO CALL THESE FUNCTIONS.  THE
C                             IBM FORTRAN77 COMPILER AND SOME OTHER
C                             COMPILERS SUPPLY IBSET AND BTEST AS
C                             INTRINSIC FUNCTIONS, SO IF THESE ARE
C                             AVAILABLE, SIMPLY DELETE THE VERSIONS
C                             BELOW.
C
      FUNCTION IBSET(INT,IBIT)
      LOGICAL            BTEST
C                             SET BIT NUMBER IBIT OF INTEGER WORD
C                             INT EQUAL TO 1.
      IBSET = INT
      IF (.NOT.BTEST(INT,IBIT)) IBSET = INT + 2**IBIT
      RETURN
      END
      LOGICAL FUNCTION BTEST(INT,IBIT)
C                             IF BIT NUMBER IBIT OF INTEGER WORD
C                             INT IS EQUAL TO 1, SET BTEST=.TRUE.
      N = INT
      ICNT = 0
    5 IF (ICNT.EQ.IBIT) GO TO 10
         N = N/2
         ICNT = ICNT+1
         GO TO 5
   10 BTEST = MOD(N,2).EQ.1
      RETURN
      END
C                             *************************************
C                             ***  NBITS RETURNS THE NUMBER OF  ***
C                             ***    USABLE BITS PER INTEGER    ***
C                             ***    WORD FOR THIS COMPUTER     ***
C                             *************************************
      FUNCTION NBITS(IDUMMY)
      NBITS = 32
      RETURN
      END

